Submitted By: Zack Winkles <winkie AT linuxfromscratch DOT org>
Date: 2004-04-06
Initial Package Version: 3.4.0
Origin: Idea originally developed by Ryan Oliver and Greg Schafer for
	the Pure LFS project.
	More architectures added by Zack Winkles.
	Further fine tunings by Greg Schafer.
	Modified for gcc 3.3.2 by Oliver Brakmann.
	Rediffed against gcc 3.4.0 by Zack Winkles.
Description: This patch modifies the location of the dynamic linker for
	the GCC Pass 2 build in LFS Chapter 5.

diff -Naur gcc-3.4.0.orig/gcc/config/alpha/linux-elf.h gcc-3.4.0/gcc/config/alpha/linux-elf.h
--- gcc-3.4.0.orig/gcc/config/alpha/linux-elf.h	2003-09-27 00:48:12.000000000 -0400
+++ gcc-3.4.0/gcc/config/alpha/linux-elf.h	2004-04-05 14:12:10.000000000 -0400
@@ -27,7 +27,7 @@
 #define SUBTARGET_EXTRA_SPECS \
 { "elf_dynamic_linker", ELF_DYNAMIC_LINKER },
 
-#define ELF_DYNAMIC_LINKER	"/lib/ld-linux.so.2"
+#define ELF_DYNAMIC_LINKER	"/tools/lib/ld-linux.so.2"
 
 #define LINK_SPEC "-m elf64alpha %{G*} %{relax:-relax}		\
   %{O*:-O3} %{!O*:-O1}						\
diff -Naur gcc-3.4.0.orig/gcc/config/arm/linux-elf.h gcc-3.4.0/gcc/config/arm/linux-elf.h
--- gcc-3.4.0.orig/gcc/config/arm/linux-elf.h	2004-01-31 01:18:11.000000000 -0500
+++ gcc-3.4.0/gcc/config/arm/linux-elf.h	2004-04-05 14:11:06.000000000 -0400
@@ -87,7 +87,7 @@
    %{shared:-shared} \
    %{symbolic:-Bsymbolic} \
    %{rdynamic:-export-dynamic} \
-   %{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.2} \
+   %{!dynamic-linker:-dynamic-linker /tools/lib/ld-linux.so.2} \
    -X \
    %{mbig-endian:-EB}" \
    SUBTARGET_EXTRA_LINK_SPEC
diff -Naur gcc-3.4.0.orig/gcc/config/i386/kfreebsdgnu.h gcc-3.4.0/gcc/config/i386/kfreebsdgnu.h
--- gcc-3.4.0.orig/gcc/config/i386/kfreebsdgnu.h	2003-10-21 05:52:47.000000000 -0400
+++ gcc-3.4.0/gcc/config/i386/kfreebsdgnu.h	2004-04-05 14:14:37.000000000 -0400
@@ -31,5 +31,5 @@
     %{!ibcs: \
       %{!static: \
 	%{rdynamic:-export-dynamic} \
-	%{!dynamic-linker:-dynamic-linker /lib/ld.so.1}} \
+	%{!dynamic-linker:-dynamic-linker /tools/lib/ld.so.1}} \
 	%{static:-static}}}"
diff -Naur gcc-3.4.0.orig/gcc/config/i386/linux.h gcc-3.4.0/gcc/config/i386/linux.h
--- gcc-3.4.0.orig/gcc/config/i386/linux.h	2003-11-28 22:08:10.000000000 -0500
+++ gcc-3.4.0/gcc/config/i386/linux.h	2004-04-05 14:22:20.883035720 -0400
@@ -115,7 +115,7 @@
     %{!ibcs: \
       %{!static: \
 	%{rdynamic:-export-dynamic} \
-	%{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.1}} \
+	%{!dynamic-linker:-dynamic-linker /tools/lib/ld-linux.so.1}} \
 	%{static:-static}}}"
 #else
 #define LINK_SPEC "-m elf_i386 %{shared:-shared} \
@@ -123,7 +123,7 @@
     %{!ibcs: \
       %{!static: \
 	%{rdynamic:-export-dynamic} \
-	%{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.2}} \
+	%{!dynamic-linker:-dynamic-linker /tools/lib/ld-linux.so.2}} \
 	%{static:-static}}}"
 #endif
 
diff -Naur gcc-3.4.0.orig/gcc/config/i386/linux64.h gcc-3.4.0/gcc/config/i386/linux64.h
--- gcc-3.4.0.orig/gcc/config/i386/linux64.h	2003-11-28 22:08:10.000000000 -0500
+++ gcc-3.4.0/gcc/config/i386/linux64.h	2004-04-05 14:13:08.000000000 -0400
@@ -60,8 +60,8 @@
   %{!shared: \
     %{!static: \
       %{rdynamic:-export-dynamic} \
-      %{m32:%{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.2}} \
-      %{!m32:%{!dynamic-linker:-dynamic-linker /lib64/ld-linux-x86-64.so.2}}} \
+      %{m32:%{!dynamic-linker:-dynamic-linker /tools/lib/ld-linux.so.2}} \
+      %{!m32:%{!dynamic-linker:-dynamic-linker /tools/lib64/ld-linux-x86-64.so.2}}} \
     %{static:-static}}"
 
 #define MULTILIB_DEFAULTS { "m64" }
diff -Naur gcc-3.4.0.orig/gcc/config/ia64/linux.h gcc-3.4.0/gcc/config/ia64/linux.h
--- gcc-3.4.0.orig/gcc/config/ia64/linux.h	2004-02-07 02:56:17.000000000 -0500
+++ gcc-3.4.0/gcc/config/ia64/linux.h	2004-04-05 14:13:31.000000000 -0400
@@ -43,7 +43,7 @@
   %{!shared: \
     %{!static: \
       %{rdynamic:-export-dynamic} \
-      %{!dynamic-linker:-dynamic-linker /lib/ld-linux-ia64.so.2}} \
+      %{!dynamic-linker:-dynamic-linker /tools/lib/ld-linux-ia64.so.2}} \
       %{static:-static}}"
 
 
diff -Naur gcc-3.4.0.orig/gcc/config/linux.h gcc-3.4.0/gcc/config/linux.h
--- gcc-3.4.0.orig/gcc/config/linux.h	2003-11-28 22:08:10.000000000 -0500
+++ gcc-3.4.0/gcc/config/linux.h	2004-04-05 14:14:09.000000000 -0400
@@ -124,3 +124,7 @@
 #endif
 
 #define TARGET_HAS_F_SETLKW
+
+/* Remove /usr/include from the end of the include search path.  */
+#undef STANDARD_INCLUDE_DIR
+#define STANDARD_INCLUDE_DIR 0
diff -Naur gcc-3.4.0.orig/gcc/config/m32r/linux.h gcc-3.4.0/gcc/config/m32r/linux.h
--- gcc-3.4.0.orig/gcc/config/m32r/linux.h	2003-12-31 05:33:02.000000000 -0500
+++ gcc-3.4.0/gcc/config/m32r/linux.h	2004-04-05 14:11:12.000000000 -0400
@@ -66,7 +66,7 @@
     %{!ibcs: \
       %{!static: \
 	%{rdynamic:-export-dynamic} \
-	%{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.2}} \
+	%{!dynamic-linker:-dynamic-linker /tools/lib/ld-linux.so.2}} \
 	%{static:-static}}}"
 #else
 #define LINK_SPEC "%(link_cpu) -m m32relf_linux %{shared:-shared} \
@@ -74,7 +74,7 @@
     %{!ibcs: \
       %{!static: \
 	%{rdynamic:-export-dynamic} \
-	%{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.2}} \
+	%{!dynamic-linker:-dynamic-linker /tools/lib/ld-linux.so.2}} \
 	%{static:-static}}}"
 #endif
 
diff -Naur gcc-3.4.0.orig/gcc/config/m68k/linux.h gcc-3.4.0/gcc/config/m68k/linux.h
--- gcc-3.4.0.orig/gcc/config/m68k/linux.h	2003-11-28 22:08:11.000000000 -0500
+++ gcc-3.4.0/gcc/config/m68k/linux.h	2004-04-05 14:14:46.000000000 -0400
@@ -136,7 +136,7 @@
   %{!shared: \
     %{!static: \
       %{rdynamic:-export-dynamic} \
-      %{!dynamic-linker*:-dynamic-linker /lib/ld.so.1}} \
+      %{!dynamic-linker*:-dynamic-linker /tools/lib/ld.so.1}} \
     %{static}}"
 
 /* For compatibility with linux/a.out */
diff -Naur gcc-3.4.0.orig/gcc/config/mips/linux.h gcc-3.4.0/gcc/config/mips/linux.h
--- gcc-3.4.0.orig/gcc/config/mips/linux.h	2004-02-19 16:45:21.000000000 -0500
+++ gcc-3.4.0/gcc/config/mips/linux.h	2004-04-05 14:14:54.000000000 -0400
@@ -116,7 +116,7 @@
     %{!ibcs: \
       %{!static: \
         %{rdynamic:-export-dynamic} \
-        %{!dynamic-linker:-dynamic-linker /lib/ld.so.1}} \
+        %{!dynamic-linker:-dynamic-linker /tools/lib/ld.so.1}} \
         %{static:-static}}}"
 
 #undef SUBTARGET_ASM_SPEC
diff -Naur gcc-3.4.0.orig/gcc/config/mips/linux64.h gcc-3.4.0/gcc/config/mips/linux64.h
--- gcc-3.4.0.orig/gcc/config/mips/linux64.h	2003-08-23 13:14:11.000000000 -0400
+++ gcc-3.4.0/gcc/config/mips/linux64.h	2004-04-05 14:15:11.000000000 -0400
@@ -65,9 +65,9 @@
       %{!static: \
         %{rdynamic:-export-dynamic} \
         %{!dynamic-linker: \
-	  %{mabi=n32: -dynamic-linker /lib32/ld.so.1} \
-	  %{mabi=64: -dynamic-linker /lib64/ld.so.1} \
-	  %{mabi=32: -dynamic-linker /lib/ld.so.1}}} \
+	  %{mabi=n32: -dynamic-linker /tools/lib32/ld.so.1} \
+	  %{mabi=64: -dynamic-linker /tools/lib64/ld.so.1} \
+	  %{mabi=32: -dynamic-linker /tools/lib/ld.so.1}}} \
       %{static:-static}}} \
 %{mabi=n32:-melf32%{EB:b}%{EL:l}tsmipn32} \
 %{mabi=64:-melf64%{EB:b}%{EL:l}tsmip} \
diff -Naur gcc-3.4.0.orig/gcc/config/mn10300/linux.h gcc-3.4.0/gcc/config/mn10300/linux.h
--- gcc-3.4.0.orig/gcc/config/mn10300/linux.h	2003-11-28 22:08:11.000000000 -0500
+++ gcc-3.4.0/gcc/config/mn10300/linux.h	2004-04-05 14:15:26.000000000 -0400
@@ -37,7 +37,7 @@
 #define LINK_SPEC "%{mrelax:--relax} %{shared:-shared} \
    %{!static: \
      %{rdynamic:-export-dynamic} \
-     %{!dynamic-linker:-dynamic-linker /lib/ld.so.1}} \
+     %{!dynamic-linker:-dynamic-linker /tools/lib/ld.so.1}} \
    %{static:-static}"
 
 #undef  LIB_SPEC
diff -Naur gcc-3.4.0.orig/gcc/config/pa/pa-linux.h gcc-3.4.0/gcc/config/pa/pa-linux.h
--- gcc-3.4.0.orig/gcc/config/pa/pa-linux.h	2003-11-28 22:08:11.000000000 -0500
+++ gcc-3.4.0/gcc/config/pa/pa-linux.h	2004-04-05 14:15:34.000000000 -0400
@@ -83,7 +83,7 @@
   %{!shared: \
     %{!static: \
       %{rdynamic:-export-dynamic} \
-      %{!dynamic-linker:-dynamic-linker /lib/ld.so.1}} \
+      %{!dynamic-linker:-dynamic-linker /tools/lib/ld.so.1}} \
       %{static:-static}}"
 
 /* glibc's profiling functions don't need gcc to allocate counters.  */
diff -Naur gcc-3.4.0.orig/gcc/config/rs6000/linux64.h gcc-3.4.0/gcc/config/rs6000/linux64.h
--- gcc-3.4.0.orig/gcc/config/rs6000/linux64.h	2004-03-10 22:25:06.000000000 -0500
+++ gcc-3.4.0/gcc/config/rs6000/linux64.h	2004-04-05 14:16:04.000000000 -0400
@@ -340,11 +340,11 @@
 
 #define LINK_OS_LINUX_SPEC32 "-m elf32ppclinux %{!shared: %{!static: \
   %{rdynamic:-export-dynamic} \
-  %{!dynamic-linker:-dynamic-linker /lib/ld.so.1}}}"
+  %{!dynamic-linker:-dynamic-linker /tools/lib/ld.so.1}}}"
 
 #define LINK_OS_LINUX_SPEC64 "-m elf64ppc %{!shared: %{!static: \
   %{rdynamic:-export-dynamic} \
-  %{!dynamic-linker:-dynamic-linker /lib64/ld64.so.1}}}"
+  %{!dynamic-linker:-dynamic-linker /tools/lib64/ld64.so.1}}}"
 
 #undef  TOC_SECTION_ASM_OP
 #define TOC_SECTION_ASM_OP \
diff -Naur gcc-3.4.0.orig/gcc/config/rs6000/sysv4.h gcc-3.4.0/gcc/config/rs6000/sysv4.h
--- gcc-3.4.0.orig/gcc/config/rs6000/sysv4.h	2004-03-02 17:34:58.000000000 -0500
+++ gcc-3.4.0/gcc/config/rs6000/sysv4.h	2004-04-05 14:15:50.000000000 -0400
@@ -1127,7 +1127,7 @@
 
 #define LINK_OS_LINUX_SPEC "-m elf32ppclinux %{!shared: %{!static: \
   %{rdynamic:-export-dynamic} \
-  %{!dynamic-linker:-dynamic-linker /lib/ld.so.1}}}"
+  %{!dynamic-linker:-dynamic-linker /tools/lib/ld.so.1}}}"
 
 #if defined(HAVE_LD_EH_FRAME_HDR)
 # define LINK_EH_SPEC "%{!static:--eh-frame-hdr} "
@@ -1158,7 +1158,7 @@
 
 #define LINK_OS_GNU_SPEC "-m elf32ppclinux %{!shared: %{!static: \
   %{rdynamic:-export-dynamic} \
-  %{!dynamic-linker:-dynamic-linker /lib/ld.so.1}}}"
+  %{!dynamic-linker:-dynamic-linker /tools/lib/ld.so.1}}}"
 
 #define CPP_OS_GNU_SPEC "-D__unix__ -D__gnu_hurd__ -D__GNU__	\
 %{!undef:					                \
diff -Naur gcc-3.4.0.orig/gcc/config/s390/linux.h gcc-3.4.0/gcc/config/s390/linux.h
--- gcc-3.4.0.orig/gcc/config/s390/linux.h	2003-11-28 22:08:12.000000000 -0500
+++ gcc-3.4.0/gcc/config/s390/linux.h	2004-04-05 14:16:40.000000000 -0400
@@ -86,8 +86,8 @@
       %{!static: \
 	%{rdynamic:-export-dynamic} \
 	%{!dynamic-linker: \
-          %{m31:-dynamic-linker /lib/ld.so.1} \
-          %{m64:-dynamic-linker /lib/ld64.so.1}}}}"
+          %{m31:-dynamic-linker /tools/lib/ld.so.1} \
+          %{m64:-dynamic-linker /tools/lib/ld64.so.1}}}}"
 
 
 #define TARGET_ASM_FILE_END file_end_indicate_exec_stack
diff -Naur gcc-3.4.0.orig/gcc/config/sh/linux.h gcc-3.4.0/gcc/config/sh/linux.h
--- gcc-3.4.0.orig/gcc/config/sh/linux.h	2004-01-11 21:29:13.000000000 -0500
+++ gcc-3.4.0/gcc/config/sh/linux.h	2004-04-05 14:11:15.000000000 -0400
@@ -77,7 +77,7 @@
   "%{shared:-shared} \
    %{!static: \
      %{rdynamic:-export-dynamic} \
-     %{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.2}} \
+     %{!dynamic-linker:-dynamic-linker /tools/lib/ld-linux.so.2}} \
    %{static:-static}"
 
 #undef LIB_SPEC
diff -Naur gcc-3.4.0.orig/gcc/config/sparc/linux.h gcc-3.4.0/gcc/config/sparc/linux.h
--- gcc-3.4.0.orig/gcc/config/sparc/linux.h	2004-04-01 11:13:08.000000000 -0500
+++ gcc-3.4.0/gcc/config/sparc/linux.h	2004-04-05 14:22:33.315145752 -0400
@@ -154,21 +154,21 @@
 
 #undef  LINK_SPEC
 #ifdef USE_GNULIBC_1
-#define LINK_SPEC "-m elf32_sparc -Y P,/usr/lib %{shared:-shared} \
+#define LINK_SPEC "-m elf32_sparc -Y P,/tools/lib %{shared:-shared} \
   %{!shared: \
     %{!ibcs: \
       %{!static: \
         %{rdynamic:-export-dynamic} \
-        %{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.1}} \
+        %{!dynamic-linker:-dynamic-linker /tools/lib/ld-linux.so.1}} \
         %{static:-static}}}"
 #else
-#define LINK_SPEC "-m elf32_sparc -Y P,/usr/lib %{shared:-shared} \
+#define LINK_SPEC "-m elf32_sparc -Y P,/tools/lib %{shared:-shared} \
   %{!mno-relax:%{!r:-relax}} \
   %{!shared: \
     %{!ibcs: \
       %{!static: \
         %{rdynamic:-export-dynamic} \
-        %{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.2}} \
+        %{!dynamic-linker:-dynamic-linker /tools/lib/ld-linux.so.2}} \
         %{static:-static}}}"
 #endif
 
diff -Naur gcc-3.4.0.orig/gcc/config/sparc/linux64.h gcc-3.4.0/gcc/config/sparc/linux64.h
--- gcc-3.4.0.orig/gcc/config/sparc/linux64.h	2004-04-01 11:13:09.000000000 -0500
+++ gcc-3.4.0/gcc/config/sparc/linux64.h	2004-04-05 14:21:36.191829816 -0400
@@ -164,21 +164,21 @@
   { "link_arch_default", LINK_ARCH_DEFAULT_SPEC },	  \
   { "link_arch",	 LINK_ARCH_SPEC },
     
-#define LINK_ARCH32_SPEC "-m elf32_sparc -Y P,/usr/lib %{shared:-shared} \
+#define LINK_ARCH32_SPEC "-m elf32_sparc -Y P,/tools/lib %{shared:-shared} \
   %{!shared: \
     %{!ibcs: \
       %{!static: \
         %{rdynamic:-export-dynamic} \
-        %{!dynamic-linker:-dynamic-linker /lib/ld-linux.so.2}} \
+        %{!dynamic-linker:-dynamic-linker /tools/lib/ld-linux.so.2}} \
         %{static:-static}}} \
 "
 
-#define LINK_ARCH64_SPEC "-m elf64_sparc -Y P,/usr/lib64 %{shared:-shared} \
+#define LINK_ARCH64_SPEC "-m elf64_sparc -Y P,/tools/lib64 %{shared:-shared} \
   %{!shared: \
     %{!ibcs: \
       %{!static: \
         %{rdynamic:-export-dynamic} \
-        %{!dynamic-linker:-dynamic-linker /lib64/ld-linux.so.2}} \
+        %{!dynamic-linker:-dynamic-linker /tools/lib64/ld-linux.so.2}} \
         %{static:-static}}} \
 "
 
@@ -233,12 +233,12 @@
 #else /* !SPARC_BI_ARCH */
 
 #undef LINK_SPEC
-#define LINK_SPEC "-m elf64_sparc -Y P,/usr/lib64 %{shared:-shared} \
+#define LINK_SPEC "-m elf64_sparc -Y P,/tools/lib64 %{shared:-shared} \
   %{!shared: \
     %{!ibcs: \
       %{!static: \
         %{rdynamic:-export-dynamic} \
-        %{!dynamic-linker:-dynamic-linker /lib64/ld-linux.so.2}} \
+        %{!dynamic-linker:-dynamic-linker /tools/lib64/ld-linux.so.2}} \
         %{static:-static}}} \
 %{mlittle-endian:-EL} \
 %{!mno-relax:%{!r:-relax}} \
diff -Naur gcc-3.4.0.orig/gcc/config/xtensa/linux.h gcc-3.4.0/gcc/config/xtensa/linux.h
--- gcc-3.4.0.orig/gcc/config/xtensa/linux.h	2003-11-28 22:08:13.000000000 -0500
+++ gcc-3.4.0/gcc/config/xtensa/linux.h	2004-04-05 14:16:51.000000000 -0400
@@ -50,7 +50,7 @@
     %{!ibcs: \
       %{!static: \
         %{rdynamic:-export-dynamic} \
-        %{!dynamic-linker:-dynamic-linker /lib/ld.so.1}} \
+        %{!dynamic-linker:-dynamic-linker /tools/lib/ld.so.1}} \
       %{static:-static}}}"
 
 #undef LOCAL_LABEL_PREFIX
